=== modified file 'src/com/goldencode/p2j/ui/TreeNodeCollectionResource.java'
--- src/com/goldencode/p2j/ui/TreeNodeCollectionResource.java	2021-02-09 09:35:10 +0000
+++ src/com/goldencode/p2j/ui/TreeNodeCollectionResource.java	2021-06-17 17:07:28 +0000
@@ -91,14 +91,12 @@
  *        node type
  * @param <C> 
  *        config type
- * @param <R> 
+ * @param  <TreeNodeResource>  
  *        resource type
 */
-public class TreeNodeCollectionResource<N extends TreeNodeEntry,
-                                        C extends TreeConfig<N>,
-                                        R extends TreeNodeResource<N>>
+public class TreeNodeCollectionResource
 extends HandleResource
-implements TreeNodeCollection<R>,
+implements TreeNodeCollection,
            DynamicResource
 {
    /** Represents the default key and text values for a new created tree node. */
@@ -112,13 +110,13 @@
    private final static int CHILD_NODE_RELATIONSHIP    = 4;
 
    /** The nodes collection implementation. */
-   private LinkedList<R> nodes = new LinkedList<>();
+   private LinkedList<TreeNodeFace> nodes = new LinkedList<>();
 
    /** The owning tree. */
-   private TreeWidgetBase<N, C, R> tree;
+   private TreeWidgetBase tree;
 
    /** The owning tree node. */
-   private R owner;
+   private TreeNodeResource owner;
 
    /**
     * Constructor.
@@ -128,7 +126,7 @@
     * @param   owner
     *          The owning node.
     */
-   public TreeNodeCollectionResource(TreeWidgetBase<N,C,R> tree, R owner)
+   public TreeNodeCollectionResource(final TreeWidgetBase tree, TreeNodeResource owner)
    {
       super(tree._dynamic());
       this.tree = tree;
@@ -141,7 +139,7 @@
     * @return  an Iterator.
     */
    @Override
-   public ListIterator<R> iterator()
+   public ListIterator<TreeNodeFace>  iterator()
    {
       return nodes == null ? Collections.emptyListIterator() : nodes.listIterator();
    }
@@ -155,9 +153,9 @@
     *
     * @return  an Iterator.
     */
-   public Iterator<R> recursiveIterator(boolean visibleOnly)
+   public Iterator <TreeNodeFace>  recursiveIterator(boolean visibleOnly)
    {
-      return nodes == null ? Collections.emptyIterator() : new NodesIterator<>(nodes.listIterator(),
+      return nodes == null ? Collections.emptyIterator() : new NodesIterator(nodes.listIterator(),
                                                                              visibleOnly);
    }
 
@@ -208,7 +206,7 @@
    @Override
    public handle addNextNode(handle relativeNode, character key, character text)
    {
-      return _addNodeImpl((R) relativeNode.getResource(), Location.NEXT, key, text, true);
+      return _addNodeImpl((TreeNodeFace)relativeNode.getResource(), Location.NEXT, key, text, true);
    }
 
    /**
@@ -226,7 +224,7 @@
    @Override
    public handle addChildNode(handle relativeNode, character key, character text)
    {
-      return _addNodeImpl((R) relativeNode.getResource(), Location.CHILD, key, text, true);
+      return _addNodeImpl((TreeNodeFace) relativeNode.getResource(), Location.CHILD, key, text, true);
    }
 
    /**
@@ -255,7 +253,7 @@
          return;
       }
 
-      R node = tree.findNode(key.toStringMessage());
+      TreeNodeFace node = tree.findNode(key.toStringMessage());
       _removeNode(node, null);
       tree.pushNodes();
    }
@@ -271,7 +269,7 @@
          return;
       }
 
-      ListIterator<R> it = nodes.listIterator();
+      final ListIterator <TreeNodeFace>  it = nodes.listIterator();
       while (it.hasNext())
       {
          _removeNode(it.next(), it);
@@ -358,7 +356,7 @@
       
       int index = nodeIndex.intValue();
    // the internal root node has a zero index, indices of none root nodes are 1-based
-      R node = tree.getTreeNodeByIndex(index);
+      TreeNodeFace node = tree.getTreeNodeByIndex(index);
       
       if (node == null)
       {
@@ -392,7 +390,7 @@
       
       int index = nodeIndex.intValue();
       // the internal root node has a zero index, indices of none root nodes are 1-based
-      R node = tree.getTreeNodeByIndex(index);
+      TreeNodeFace node = tree.getTreeNodeByIndex(index);
       
       if (node == null)
       {
@@ -482,8 +480,8 @@
                      character key,
                      character text)
    {
-      R relative;
-      TreeNodeCollectionResource<N, C, R> nodesCollection;
+      TreeNodeFace relative;
+      TreeNodeCollectionResource nodesCollection;
       if (anchorIndex == null || anchorIndex.isUnknown())
       {
          relative = null;
@@ -504,7 +502,7 @@
             return new handle();
          }
          
-         nodesCollection = relative.parent._getNodes();
+         nodesCollection = ((TreeNodeResource)((TreeNodeResource)relative).parent)._getNodes();
       }
       
       Location location = Location.valueOf(relationType.intValue());
@@ -516,7 +514,7 @@
          return new handle();
       }
       
-      R treeNode = tree.findNode(key.getValue());
+      TreeNodeFace treeNode = tree.findNode(key.getValue());
       
       if (treeNode != null)
       {
@@ -596,12 +594,12 @@
       
       super.delete();
       
-      TreeWidgetBase<N,C,R> tree = this.tree;
+      TreeWidgetBase tree = this.tree;
       this.tree = null;
 
       if (nodes != null)
       {
-         ListIterator<R> nodeIt = nodes.listIterator();
+         ListIterator<TreeNodeFace>  nodeIt = nodes.listIterator();
          while (nodeIt.hasNext())
          {
             _removeNode(nodeIt.next(), nodeIt);
@@ -619,19 +617,19 @@
    @Override
    public integer getCount()
    {
-      ListIterator<R> iter = iterator();
+      ListIterator<TreeNodeFace>  iter = iterator();
       
       int collect = 0;
       
-      R rootNode = tree.getTreeNodeByIndex(0);
+      TreeNodeFace rootNode = tree.getTreeNodeByIndex(0);
       
       while(iter.hasNext())
       {
-         R node = iter.next();
+         TreeNodeFace node = iter.next();
          
-         if (node._getHasChildren())
+         if (((TreeNodeResource)node)._getHasChildren())
          {
-            collect += node._getNodes().getCount().intValue();
+            collect += ((TreeNodeResource)node)._getNodes().getCount().intValue();
          }
          
          // don't take into account the internal root node
@@ -670,7 +668,7 @@
     * @param   it
     *          Optional iterator. When set, use it to remove the item from its list.
     */
-   void _removeNode(R node, ListIterator<R> it)
+   void _removeNode(final TreeNodeFace node, ListIterator <TreeNodeFace> it)
    {
       if (node == null || nodes == null)
       {
@@ -686,10 +684,10 @@
          return;
       }
 
-      node._removeCollection();
+      ((TreeNodeResource)node)._removeCollection();
 
       // resource cleanup
-      node.delete();
+      ((TreeNodeResource)node).delete();
    }
 
    /**
@@ -711,7 +709,7 @@
     *
     * @return  see above.
     */
-   int _indexOf(R node)
+   int _indexOf(final TreeNodeFace node)
    {
       return nodes == null ? -1 : nodes.indexOf(node);
    }
@@ -726,7 +724,7 @@
     * @throws  IndexOutOfBoundsException
     *          if the index is out of range (<tt>index &lt; 0 || index &gt;= size()</tt>)
     */
-   R _getNode(int index)
+   TreeNodeFace _getNode(int index)
    {
       if (nodes == null)
       {
@@ -753,7 +751,7 @@
     *
     * @return  handle with wrapped {@link TreeNodeResource} instance, or unknown if the operation fails.
     */
-   handle _addNodeImpl(R relative,
+   handle _addNodeImpl(TreeNodeFace relative,
                        Location location,
                        character key,
                        character text,
@@ -769,7 +767,7 @@
          text = key;
       }
 
-      R parent = owner;
+      TreeNodeFace parent = owner;
 
       if (location == Location.CHILD)
       {
@@ -786,7 +784,7 @@
          nodes = new LinkedList<>();
       }
       
-      R node = createNode(key.toStringMessage(), text.toStringMessage(), parent);
+      TreeNodeFace node = createNode(key.toStringMessage(), text.toStringMessage(), parent);
 
       switch (location)
       {
@@ -835,11 +833,11 @@
             }
             break;
          case CHILD:
-            parent._getNodes().nodes.addLast(node);
+            ((TreeNodeResource)parent)._getNodes().nodes.addLast(node);
             break;
       }
 
-      parent._setHasChildren(true);
+      ((TreeNodeResource)parent)._setHasChildren(true);
       tree.addNode(node, pushNodes);
       return new handle(node);
    }
@@ -861,7 +859,7 @@
     * @throws  RuntimeException
     *          when the supplied key is not unique
     */
-   private R createNode(String key, String text, R parent)
+   private TreeNodeFace createNode(String key, String text, final TreeNodeFace parent)
    {
       if (key == null || text == null || parent == null)
       {
@@ -874,11 +872,11 @@
    /**
     * Recursive nodes iterator.
     */
-   private static class NodesIterator<N extends TreeNodeEntry,T extends TreeNodeResource<N>>
-   implements Iterator<T>
+   private static class NodesIterator
+   implements Iterator<TreeNodeFace>
    {
       /** Stack of iterators to handle recursion. */
-      private Stack<ListIterator<T>> stack = new Stack<>();
+      private Stack<ListIterator<TreeNodeFace>> stack = new Stack<>();
 
       /** All or only expanded nodes to be iterated */
       private boolean visibleOnly;
@@ -888,25 +886,14 @@
        *
        * @param   node
        *          The parent node to iterate.
-       */
-      public NodesIterator(T node)
-      {
-         this(node, true);
-      }
-
-      /**
-       * Constructor.
-       *
-       * @param   node
-       *          The parent node to iterate.
        * @param   visibleOnly
        *          All or only expanded nodes to be iterated.
        */
-      public NodesIterator(T node, boolean visibleOnly)
+      public NodesIterator(final TreeNodeFace node, boolean visibleOnly)
       {
          if (node != null && node.isNodeExpanded().booleanValue())
          {
-            LinkedList<T> nodes = (LinkedList<T>)node._getNodes().nodes;
+            LinkedList<TreeNodeFace> nodes = (LinkedList<TreeNodeFace>)((TreeNodeResource)node)._getNodes().nodes;
             stack.push(nodes == null ? Collections.emptyListIterator() : nodes.listIterator());
          }
 
@@ -921,7 +908,7 @@
        * @param   visibleOnly
        *          All or only expanded nodes to be iterated.
        */
-      public NodesIterator(ListIterator<T> nodes, boolean visibleOnly)
+      public NodesIterator(ListIterator<TreeNodeFace> nodes, boolean visibleOnly)
       {
          stack.push(nodes);
          this.visibleOnly = visibleOnly;
@@ -937,7 +924,7 @@
       @Override
       public boolean hasNext()
       {
-         for (Iterator<T> it : stack)
+         for (ListIterator<TreeNodeFace> it : stack)
          {
             if (it.hasNext())
             {
@@ -955,7 +942,7 @@
        * @throws NoSuchElementException if the iteration has no more elements
        */
       @Override
-      public T next()
+      public TreeNodeFace next()
       {
          if (stack.isEmpty())
          {
@@ -967,27 +954,27 @@
             stack.pop();
          }
 
-         Iterator<T> it = stack.isEmpty() ? null : stack.peek();
+         Iterator<TreeNodeFace> it = stack.isEmpty() ? null : stack.peek();
 
          if (it == null || !it.hasNext())
          {
             throw new NoSuchElementException();
          }
 
-         TreeNodeResource<N> node = it.next();
+         TreeNodeFace node = it.next();
          if (!visibleOnly || node.isNodeExpanded().booleanValue())
          {
-            TreeNodeCollectionResource<N, ?, ?> coll = node._getNodes(false);
+            TreeNodeCollectionResource coll = ((TreeNodeResource)node)._getNodes(false);
             if (coll != null)
             {
                if (coll.nodes != null && !coll.nodes.isEmpty())
                {
-                  stack.push((ListIterator<T>)coll.nodes.listIterator());
+                  stack.push((ListIterator<TreeNodeFace>)coll.nodes.listIterator());
                }
             }
          }
 
-         return (T) node;
+         return node;
       }
    }
 

=== modified file 'src/com/goldencode/p2j/ui/TreeNodeEntry.java'
--- src/com/goldencode/p2j/ui/TreeNodeEntry.java	2021-01-28 21:48:33 +0000
+++ src/com/goldencode/p2j/ui/TreeNodeEntry.java	2021-06-17 17:51:29 +0000
@@ -74,13 +74,17 @@
 import java.io.*;
 import java.util.*;
 
+import com.goldencode.util.*;
+import com.google.common.base.MoreObjects.*;
+
 /**
  * Treeview node configuration.
  */
 public abstract class TreeNodeEntry
+extends AbstractPrintable
 implements Externalizable
 {
-   /** Cell tvalue types */
+   /** Cell tvalue types used for cell value serialization */
    private static final byte NULL = 0;
    private static final byte TEXT = 1;
    private static final byte NUMBER = 2;
@@ -124,6 +128,7 @@
     */
    public TreeNodeEntry()
    {
+      // no-op
    }
 
    /**
@@ -134,7 +139,7 @@
     * @param   parentId
     *          Parent node id. Use unknown when the node has no parent.
     */
-   public TreeNodeEntry(int nodeId, int parentId)
+   public TreeNodeEntry(final int nodeId, final int parentId)
    {
       this.nodeId = nodeId;
       this.parentId = parentId;
@@ -147,6 +152,20 @@
     * @param   cellIndex
     *          Cell index.
     *
+    * @return  cell value or {@code null} if the index is out of range of valid indexes
+    */
+   public Object getValue()
+   {
+      return getValue(0);
+   }
+
+   /**
+    * Returns the cell value at the specified index. The index is the index to the data model, not the
+    * actual (column) position.
+    *
+    * @param   cellIndex
+    *          Cell index.
+    *
     * @return  cell value.
     *
     * @throws  IndexOutOfBoundsException
@@ -283,14 +302,15 @@
    }
 
    /**
-    * Write cell value
+    * Write cell value.
+    * 
     * @param out
     *        output stream
     * @param value
     *        value to be written
     * @throws IOException
     */
-   protected void writeCell(ObjectOutput out, Object value) throws IOException
+   protected static void writeCell(ObjectOutput out, Object value) throws IOException
    {
       if (value == null)
       {
@@ -322,7 +342,7 @@
     * @throws IOException
     * @throws ClassNotFoundException 
     */
-   protected Object readCell(ObjectInput in) throws IOException, ClassNotFoundException
+   protected static Object readCell(ObjectInput in) throws IOException, ClassNotFoundException
    {
       byte type = in.readByte();
       switch(type)
@@ -352,4 +372,35 @@
       /** */
       INACTIVE
    }
+
+   /**
+   * Add class-specific fields to the helper.
+   *  
+   * @param stringHelper the string helper to update
+   */
+   @Override
+   public void updateStringHelper(ToStringHelper stringHelper)
+   {
+      stringHelper.add("id", nodeId);
+
+      if (parentId >= 0)
+      {
+         stringHelper.add("parentId", parentId);
+      }
+
+      if (hasChildren)
+      {
+         stringHelper.addValue("may have children");
+      }
+
+      if (expanded)
+      {
+         stringHelper.addValue("expanded");
+      }
+
+      if (tooltip != null)
+      {
+         stringHelper.add("tooltip", tooltip);
+      }
+   }
 }

=== modified file 'src/com/goldencode/p2j/ui/TreeNodeResource.java'
--- src/com/goldencode/p2j/ui/TreeNodeResource.java	2021-06-01 18:55:22 +0000
+++ src/com/goldencode/p2j/ui/TreeNodeResource.java	2021-06-17 17:24:53 +0000
@@ -101,7 +101,7 @@
  * @param <N> 
  *        node type
  */
-public abstract class TreeNodeResource<N extends TreeNodeEntry>
+public abstract class TreeNodeResource
 extends HandleResource
 implements TreeNodeFace,
            DynamicResource
@@ -140,13 +140,13 @@
    protected String key;
 
    /** The owning tree view. */
-   protected TreeWidgetBase<N, TreeConfig<N>, TreeNodeResource<N>> tree;
+   protected TreeWidgetBase tree;
 
    /** Node parent */
-   protected TreeNodeResource<N> parent;
+   protected TreeNodeFace parent;
 
    /** Child nodes */
-   protected TreeNodeCollectionResource<N, TreeConfig<N>, TreeNodeResource<N>> nodes;
+   protected TreeNodeCollectionResource nodes;
 
    /** Node tooltip */
    private String tooltip;
@@ -173,16 +173,13 @@
     * @param   parent
     *          Node parent.
     */
-   public <R extends TreeNodeResource<N>,
-           C extends TreeConfig<N>,
-           W extends TreeWidgetBase<N, C, R>> 
-          TreeNodeResource(W tree,
+   public TreeNodeResource(TreeWidgetBase tree,
                            int nodeId,
                            String key,
-                           R parent)
+                           TreeNodeFace parent)
    {
       super(tree._dynamic());
-      this.tree = (TreeWidgetBase<N, TreeConfig<N>, TreeNodeResource<N>>) tree;
+      this.tree = (TreeWidgetBase) tree;
       this.nodeId = nodeId;
       this.key = key;
       this.parent = parent;
@@ -239,7 +236,7 @@
          return;
       }
       
-      TreeNodeResource<N> treeNode = tree.findNode(newKeyValue);
+      TreeNodeFace treeNode = tree.findNode(newKeyValue);
       
       if (treeNode != null)
       {
@@ -399,7 +396,7 @@
          return new integer();
       }
 
-      int i = parent.nodes._indexOf(this);
+      int i = ((TreeNodeResource)parent).nodes._indexOf(this);
       return i < 0 ? new integer() : new integer(i);
    }
 
@@ -673,7 +670,7 @@
    {
       LinkedList<String> stack = new LinkedList<>();
       
-      TreeNodeResource<N> current = this;
+      TreeNodeFace current = this;
       
       while (current != null)
       {
@@ -692,7 +689,7 @@
          
          stack.add(label);
          
-         current = current.parent;
+         current = ((TreeNodeResource)current).parent;
       }
       
       StringBuilder pathCollector = new StringBuilder();
@@ -828,7 +825,7 @@
    @Override
    public handle getPreviousNode()
    {
-      TreeNodeCollectionResource<N, TreeConfig<N>, TreeNodeResource<N>> siblings = parent.nodes;
+      TreeNodeCollectionResource siblings = ((TreeNodeResource)parent).nodes;
       int index = siblings._indexOf(this);
       
       if (index > 0)
@@ -847,9 +844,9 @@
    @Override
    public handle getNextNode()
    {
-      TreeNodeCollectionResource<N, TreeConfig<N>, TreeNodeResource<N>> siblings = parent.nodes;
-      int index = siblings._indexOf(this);
-      int limit = siblings._getCount() - 1;
+      final TreeNodeCollectionResource siblings = ((TreeNodeResource)parent).nodes;
+      final int index = siblings._indexOf(this);
+      final int limit = siblings._getCount() - 1;
       
       if (index >= 0 && index < limit)
       {
@@ -867,7 +864,7 @@
    @Override
    public handle getFirstSiblingNode()
    {
-      TreeNodeCollectionResource<N, TreeConfig<N>, TreeNodeResource<N>> siblings = parent.nodes;
+      final TreeNodeCollectionResource siblings = ((TreeNodeResource)parent).nodes;
       
       if (siblings != null)
       {
@@ -885,7 +882,7 @@
    @Override
    public handle getLastSiblingNode()
    {
-      TreeNodeCollectionResource<N, TreeConfig<N>, TreeNodeResource<N>> siblings = parent.nodes;
+      final TreeNodeCollectionResource siblings = ((TreeNodeResource)parent).nodes;
       
       if (siblings != null)
       {
@@ -914,7 +911,7 @@
 
       super.delete();
       
-      TreeWidgetBase<N, TreeConfig<N>, TreeNodeResource<N>> tree = this.tree;
+      TreeWidgetBase tree = this.tree;
       this.tree = null;
 
       if (nodeId == 0)
@@ -923,7 +920,7 @@
       }
       else
       {
-         parent._getNodes()._removeNode(this, null);
+         ((TreeNodeResource)parent)._getNodes()._removeNode(this, null);
       }
 
       tree.removeNode(this, true);
@@ -960,7 +957,7 @@
     *
     * @return  new instance of {@link TreeNodeEntry}.
     */
-   protected abstract N saveToEntry();
+   protected abstract TreeNodeEntry saveToEntry();
 
    /**
     * The method serializes the node state into the supplied entry instance.
@@ -987,7 +984,7 @@
     * @param   entry
     *          A valid {@link TreeNodeEntry} instance.
     */
-   protected void loadFromEntry(N entry)
+   protected void loadFromEntry(final TreeNodeEntry entry)
    {
       expanded = entry.expanded;
       
@@ -999,8 +996,7 @@
     *
     * @return  see above.
     */
-   <C extends TreeConfig<N>, R extends TreeNodeResource<N>>   
-   TreeNodeCollectionResource<N, C, R> _getNodes()
+   TreeNodeCollectionResource _getNodes()
    {
       return _getNodes(true);
    }
@@ -1013,15 +1009,14 @@
     *
     * @return  see above.
     */
-   <C extends TreeConfig<N>, R extends TreeNodeResource<N>>   
-   TreeNodeCollectionResource<N, C, R> _getNodes(boolean allocate)
+   TreeNodeCollectionResource _getNodes(boolean allocate)
    {
       if (nodes == null && allocate)
       {
-         nodes = new TreeNodeCollectionResource<N, TreeConfig<N>, TreeNodeResource<N>>(tree, this);
+         nodes = new TreeNodeCollectionResource(tree, this);
       }
 
-      return (TreeNodeCollectionResource<N, C, R>)nodes;
+      return (TreeNodeCollectionResource)nodes;
    }
 
    /**
@@ -1055,8 +1050,8 @@
    int _getNodeLevel()
    {
       int level = -1;
-      TreeNodeResource<N> p = this;
-      while ((p = p.parent) != null)
+      TreeNodeFace p = this;
+      while ((p = ((TreeNodeResource)p).parent) != null)
       {
          level++;
       }
@@ -1069,7 +1064,7 @@
     *
     * @return  parent node.
     */
-   TreeNodeResource<N> _getParent()
+   TreeNodeFace _getParent()
    {
       return parent;
    }
@@ -1173,11 +1168,11 @@
    {
       if (expanded)
       {
-         TreeNodeResource<N> pNode = parent;
-         while (pNode != null && !pNode.expanded)
+         TreeNodeFace pNode = parent;
+         while (pNode != null && !((TreeNodeResource)pNode).expanded)
          {
-            pNode.expanded = true;
-            pNode = pNode.parent;
+            ((TreeNodeResource)pNode).expanded = true;
+            pNode = ((TreeNodeResource)pNode).parent;
          }
       }
 

=== modified file 'src/com/goldencode/p2j/ui/TreeView.java'
--- src/com/goldencode/p2j/ui/TreeView.java	2019-03-14 00:27:05 +0000
+++ src/com/goldencode/p2j/ui/TreeView.java	2021-06-17 17:52:14 +0000
@@ -81,4 +81,5 @@
 extends WrappedResource,
         TreeFace
 {
+   // empty
 }

=== modified file 'src/com/goldencode/p2j/ui/TreeViewConfig.java' (properties changed: +x to -x)
--- src/com/goldencode/p2j/ui/TreeViewConfig.java	2020-09-14 13:46:01 +0000
+++ src/com/goldencode/p2j/ui/TreeViewConfig.java	2021-06-17 18:05:43 +0000
@@ -74,7 +74,7 @@
  * TreeView widget configuration.
  */
 public class TreeViewConfig
-extends TreeConfig<TreeViewNodeEntry>
+extends TreeConfig
 {
    /**
     * Default constructor.
@@ -111,7 +111,7 @@
     * @return node entry instance
     */
    @Override
-   protected  Supplier<TreeViewNodeEntry> createNodeEntry()
+   protected  Supplier<TreeNodeEntry> createNodeEntry()
    {
       return TreeViewNodeEntry::new;
    }

=== modified file 'src/com/goldencode/p2j/ui/TreeViewNode.java'
--- src/com/goldencode/p2j/ui/TreeViewNode.java	2019-03-14 00:27:05 +0000
+++ src/com/goldencode/p2j/ui/TreeViewNode.java	2021-06-17 17:51:55 +0000
@@ -77,4 +77,5 @@
 public interface TreeViewNode
 extends TreeNodeFace
 {
+   // empty
 }

=== modified file 'src/com/goldencode/p2j/ui/TreeViewNodeEntry.java'
--- src/com/goldencode/p2j/ui/TreeViewNodeEntry.java	2021-01-29 14:13:08 +0000
+++ src/com/goldencode/p2j/ui/TreeViewNodeEntry.java	2021-06-16 19:56:27 +0000
@@ -78,7 +78,7 @@
 extends TreeNodeEntry
 {
    /** Node text. */
-   public String text = null;
+   /* private */ public String text = null;
 
    /**
     * Constructor.
@@ -97,7 +97,7 @@
     * @param   text
     *          Node label.
     */
-   public TreeViewNodeEntry(int nodeId, int parentId, String text)
+   public TreeViewNodeEntry(final int nodeId, final int parentId, final String text)
    {
       super(nodeId, parentId);
       this.text = text;
@@ -106,17 +106,14 @@
    /**
     * Returns the cell value at the specified index. The index is the index to the data model, not the
     * actual (column) position.
-    * <p>
-    * For TREEVIEW widget the index is ignored.
-    *
     *
     * @param   cellIndex
     *          Cell index.
     *
-    * @return  cell value.
+    * @return  cell value or {@code null} if the index is out of range of valid indexes
     */
    @Override
-   public Object getValue(int cellIndex)
+   public Object getValue(final int cellIndex)
    {
       return text;
    }

=== modified file 'src/com/goldencode/p2j/ui/TreeViewNodeResource.java'
--- src/com/goldencode/p2j/ui/TreeViewNodeResource.java	2020-09-07 16:23:31 +0000
+++ src/com/goldencode/p2j/ui/TreeViewNodeResource.java	2021-06-17 17:38:55 +0000
@@ -75,7 +75,7 @@
  * TREEVIEW-NODE resource implementation.
  */
 public class TreeViewNodeResource
-extends TreeNodeResource<TreeViewNodeEntry>
+extends TreeNodeResource
 implements TreeViewNode
 {
    private String text;
@@ -94,11 +94,11 @@
     * @param   parent
     *          Node parent.
     */
-   public TreeViewNodeResource(TreeViewWidget treeView,
+   public TreeViewNodeResource(TreeWidgetBase treeView,
                                int nodeId,
                                String key,
                                String text,
-                               TreeViewNodeResource parent)
+                               TreeNodeFace parent)
    {
       super(treeView, nodeId, key, parent);
       this.text = text;
@@ -136,9 +136,10 @@
     *
     * @return  new instance of {@link TreeViewNodeEntry}.
     */
+   @Override
    protected TreeViewNodeEntry saveToEntry()
    {
-      int parentId = parent != null ? parent.nodeId : Integer.MIN_VALUE;
+      int parentId = parent != null ? ((TreeNodeResource)parent).nodeId : Integer.MIN_VALUE;
       String effectiveText = text == null ? key : text;
       TreeViewNodeEntry entry = new TreeViewNodeEntry(nodeId, parentId, effectiveText);
       super.saveToEntry(entry);
@@ -151,10 +152,11 @@
     * @param   entry
     *          A valid {@link TreeNodeEntry} instance.
     */
-   protected void loadFromEntry(TreeViewNodeEntry entry)
+   @Override
+   protected void loadFromEntry(final TreeNodeEntry entry)
    {
       super.loadFromEntry(entry);
       
-      text = entry.text;
+      text = entry.getValue().toString();
    }
 }

=== modified file 'src/com/goldencode/p2j/ui/TreeViewWidget.java'
--- src/com/goldencode/p2j/ui/TreeViewWidget.java	2021-06-01 18:55:22 +0000
+++ src/com/goldencode/p2j/ui/TreeViewWidget.java	2021-06-17 17:20:26 +0000
@@ -79,7 +79,7 @@
  * Server side TreeView widget implementation.
  */
 public class TreeViewWidget
-extends TreeWidgetBase<TreeViewNodeEntry, TreeViewConfig, TreeViewNodeResource>
+extends TreeWidgetBase
 implements TreeView
 {
    /**
@@ -114,7 +114,7 @@
     * @return  new node instance.
     */
    @Override
-   protected TreeViewNodeResource createNode(String key, String text, TreeViewNodeResource parent)
+   protected TreeNodeFace createNode(String key, String text, TreeNodeFace parent)
    {
       int nodeId = getNextNodeId();
       return new TreeViewNodeResource(this, nodeId, key, text, parent);

